use include_lines::{static_include_lines};
use rand::Rng;
static_include_lines!(WORD_LIST_ENGLISH, "data/words_english.txt");
static_include_lines!(WORD_LIST_FRENCH, "data/words_french.txt");

pub struct WordList {
    pub words: Vec<String>,
    pub chars: Vec<char>
}

impl WordList {
    pub fn new(num_of_words: u16) -> WordList {
        let mut rng = rand::rng();
        let mut chars_to_write: Vec<char> = Vec::new();
        let mut words_to_write: Vec<String> = Vec::new();
        let words = Self::get_words();
        for _ in 0..num_of_words {
            let i = rng.random_range(0..words.len());
            let word = words.get(i).unwrap();
            words_to_write.push(word.to_owned());
            for c in word.chars() {
                chars_to_write.push(c);
            }
            chars_to_write.push(' ');
        }
        WordList{ words: words_to_write, chars: chars_to_write }
    }

    fn get_words() -> Vec<String> {
        let mut words: Vec<String> = Vec::new();

        for word in WORD_LIST_FRENCH {
            words.push(word.to_owned());
        }

        words
    }
}
